## jdupes 1.20.2

=== Makefile ===
# jdupes Makefile

#####################################################################
# Standand User Configuration Section                               #
#####################################################################

# PREFIX determines where files will be installed. Common examples
# include "/usr" or "/usr/local".
PREFIX = /usr/local

# Certain platforms do not support long options (command line options).
# To disable long options, uncomment the following line.
#CFLAGS += -DOMIT_GETOPT_LONG

# Uncomment for -B/--dedupe.
# This can also be enabled at build time: 'make ENABLE_DEDUPE=1'
#CFLAGS += -DENABLE_DEDUPE

# Uncomment for low memory usage at the expense of speed and features
# This can be enabled at build time: 'make LOW_MEMORY=1'
#LOW_MEMORY=1

# Uncomment this to build in hardened mode.
# This can be enabled at build time: 'make HARDEN=1'
#HARDEN=1

#####################################################################
# Developer Configuration Section                                   #
#####################################################################

# PROGRAM_NAME determines the installation name and manual page name
PROGRAM_NAME = jdupes

# BIN_DIR indicates directory where program is to be installed.
# Suggested value is "$(PREFIX)/bin"
BIN_DIR = $(PREFIX)/bin

# MAN_DIR indicates directory where the jdupes man page is to be
# installed. Suggested value is "$(PREFIX)/man/man1"
MAN_BASE_DIR = $(PREFIX)/share/man
MAN_DIR = $(MAN_BASE_DIR)/man1
MAN_EXT = 1

# Required External Tools
INSTALL = install	# install : UCB/GNU Install compatible
#INSTALL = ginstall
RM      = rm -f
RMDIR	= rmdir -p
MKDIR   = mkdir -p
#MKDIR   = mkdirhier
#MKDIR   = mkinstalldirs

# Make Configuration
CC ?= gcc
COMPILER_OPTIONS = -Wall -Wwrite-strings -Wcast-align -Wstrict-aliasing -Wstrict-prototypes -Wpointer-arith -Wundef
COMPILER_OPTIONS += -Wshadow -Wfloat-equal -Waggregate-return -Wcast-qual -Wswitch-default -Wswitch-enum -Wconversion -Wunreachable-code -Wformat=2
COMPILER_OPTIONS += -std=gnu99 -O2 -g -D_FILE_OFFSET_BITS=64 -fstrict-aliasing -pipe
COMPILER_OPTIONS += -DSMA_MAX_FREE=11

#####################################################################
# no need to modify anything beyond this point                      #
#####################################################################

# Don't use unsupported compiler options on gcc 3/4 (OS X 10.5.8 Xcode)
GCCVERSION = $(shell expr `gcc -v 2>&1 | grep 'gcc version ' | cut -d\  -f3 | cut -d. -f1` \>= 5)
ifeq "$(GCCVERSION)" "1"
	COMPILER_OPTIONS += -Wextra -Wstrict-overflow=5 -Winit-self
endif

# Debugging code inclusion
ifdef LOUD
DEBUG=1
COMPILER_OPTIONS += -DLOUD_DEBUG
endif
ifdef DEBUG
COMPILER_OPTIONS += -DDEBUG
else
COMPILER_OPTIONS += -DNDEBUG
endif
ifdef HARDEN
COMPILER_OPTIONS += -Wformat -Wformat-security -D_FORTIFY_SOURCE=2 -fstack-protector-strong -fPIE -fpie -Wl,-z,relro -Wl,-z,now
endif

# Catch someone trying to enable BTRFS in flags and turn on ENABLE_DEDUPE
ifneq (,$(findstring DENABLE_BTRFS,$(CFLAGS) $(CFLAGS_EXTRA)))
	ENABLE_DEDUPE=1
endif
ifneq (,$(findstring DENABLE_DEDUPE,$(CFLAGS) $(CFLAGS_EXTRA)))
	ENABLE_DEDUPE=1
endif

UNAME_S=$(shell uname -s)

# MinGW needs this for printf() conversions to work
ifeq ($(OS), Windows_NT)
	ifndef NO_UNICODE
		UNICODE=1
		COMPILER_OPTIONS += -municode
		PROGRAM_SUFFIX=.exe
	endif
	COMPILER_OPTIONS += -D__USE_MINGW_ANSI_STDIO=1 -DON_WINDOWS=1
	OBJS += win_stat.o
	ifeq ($(UNAME_S), MINGW32_NT-5.1)
		OBJS += winres_xp.o
	else
		OBJS += winres.o
	endif
	override undefine ENABLE_DEDUPE
endif

# Don't do clonefile on Mac OS X < 10.13 (High Sierra)
ifeq ($(UNAME_S), Darwin)
	DARWINVER := $(shell expr `uname -r | cut -d. -f1` \< 17)
	ifeq "$(DARWINVER)" "1"
		COMPILER_OPTIONS += -DNO_CLONEFILE=1
	endif
endif

# Compatibility mappings for dedupe feature
ifdef ENABLE_BTRFS
ENABLE_DEDUPE=1
endif
ifdef STATIC_BTRFS_H
STATIC_DEDUPE_H=1
endif

# Dedupe feature (originally only BTRFS, now generalized)
ifdef ENABLE_DEDUPE
COMPILER_OPTIONS += -DENABLE_DEDUPE
OBJS += act_dedupefiles.o
else
OBJS_CLEAN += act_dedupefiles.o
endif
ifdef STATIC_DEDUPE_H
COMPILER_OPTIONS += -DSTATIC_DEDUPE_H
endif

# Low memory mode
ifdef LOW_MEMORY
COMPILER_OPTIONS += -DLOW_MEMORY -DSMA_PAGE_SIZE=32768 -DCHUNK_SIZE=16384 -DNO_HARDLINKS -DNO_SYMLINKS -DNO_USER_ORDER -DNO_PERMS
endif

CFLAGS += $(COMPILER_OPTIONS) $(CFLAGS_EXTRA)

INSTALL_PROGRAM = $(INSTALL) -m 0755
INSTALL_DATA    = $(INSTALL) -m 0644

# ADDITIONAL_OBJECTS - some platforms will need additional object files
# to support features not supplied by their vendor. Eg: GNU getopt()
#ADDITIONAL_OBJECTS += getopt.o

OBJS += jdupes.o jody_paths.o jody_sort.o jody_win_unicode.o jody_strtoepoch.o string_malloc.o oom.o
OBJS += jody_cacheinfo.o
OBJS += act_deletefiles.o act_linkfiles.o act_printmatches.o act_summarize.o act_printjson.o
OBJS += xxhash.o
OBJS += $(ADDITIONAL_OBJECTS)

all: $(PROGRAM_NAME)

static: $(PROGRAM_NAME)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $(PROGRAM_NAME) $(OBJS) -static

static_stripped: $(PROGRAM_NAME)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $(PROGRAM_NAME) $(OBJS) -static
	strip $(PROGRAM_NAME)

$(PROGRAM_NAME): $(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $(PROGRAM_NAME) $(OBJS)

winres.o: winres.rc winres.manifest.xml
	./tune_winres.sh
	windres winres.rc winres.o

winres_xp.o: winres_xp.rc
	./tune_winres.sh
	windres winres_xp.rc winres_xp.o

installdirs:
	test -e $(DESTDIR)$(BIN_DIR) || $(MKDIR) $(DESTDIR)$(BIN_DIR)
	test -e $(DESTDIR)$(MAN_DIR) || $(MKDIR) $(DESTDIR)$(MAN_DIR)

install: $(PROGRAM_NAME) installdirs
	$(INSTALL_PROGRAM)	$(PROGRAM_NAME)   $(DESTDIR)$(BIN_DIR)/$(PROGRAM_NAME)
	$(INSTALL_DATA)		$(PROGRAM_NAME).1 $(DESTDIR)$(MAN_DIR)/$(PROGRAM_NAME).$(MAN_EXT)

uninstalldirs:
	-test -e $(DESTDIR)$(BIN_DIR) && $(RMDIR) $(DESTDIR)$(BIN_DIR)
	-test -e $(DESTDIR)$(MAN_DIR) && $(RMDIR) $(DESTDIR)$(MAN_DIR)

uninstall: uninstalldirs
	$(RM)	$(DESTDIR)$(BIN_DIR)/$(PROGRAM_NAME)
	$(RM)	$(DESTDIR)$(MAN_DIR)/$(PROGRAM_NAME).$(MAN_EXT)

test:
	./test.sh

stripped: $(PROGRAM_NAME)
	strip $(PROGRAM_NAME)$(PROGRAM_SUFFIX)

clean:
	$(RM) $(OBJS) $(OBJS_CLEAN) build_date.h $(PROGRAM_NAME) $(PROGRAM_NAME).exe *~ *.gcno *.gcda *.gcov

distclean: clean
	$(RM) *.pkg.tar.*
	$(RM) -r jdupes-*-*/ jdupes-*-*.zip

chrootpackage:
	+./chroot_build.sh
package:
	+./generate_packages.sh

=== debian/changelog ===
jdupes (1.20.2-1) unstable; urgency=medium

  * New upstream version 1.20.2.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 08 Nov 2021 20:31:22 -0300

jdupes (1.20.1-1) unstable; urgency=medium

  * New upstream version 1.20.1.
  * debian/control: bumped Standards-Version to 4.6.0.1.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 28 Oct 2021 23:33:07 -0300

jdupes (1.20.0-1) unstable; urgency=medium

  * New upstream version 1.20.0.
  * debian/copyright:
      - Added a block for oom.c and oom.h.
      - Updated upstream and packaging copyright years.
  * debian/tests/control: removed '-n' from a test because this option was
    deprecated in jdupes 1.20.0.
  * debian/watch: updated the search rule to make it compliant with new
    standards of the GitHub.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 15 Aug 2021 11:59:09 -0300

=== debian/control ===
Source: jdupes
Section: utils
Priority: optional
Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.6.0.1
Rules-Requires-Root: no
Homepage: https://github.com/jbruchon/jdupes
Vcs-Browser: https://salsa.debian.org/debian/jdupes
Vcs-Git: https://salsa.debian.org/debian/jdupes.git

Package: jdupes
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: identify and delete or link duplicate files
 jdupes is a program based in fdupes. The main goal of jdupes is identify
 and taking actions upon duplicate files. In comparison with fdupes, jdupes
 is heavily modified from and improved.
 .
 The biggest reason to use jdupes is raw speed. In testing on various data
 sets, jdupes is over 7 times faster than fdupes-1.51 on average.
 .
 Code in jdupes is written with data loss avoidance as the highest priority.
 If a choice must be made between being aggressive or careful, the careful
 way is always chosen.
 .
 jdupes includes features that are not found in fdupes. Examples of such
 features include btrfs block-level deduplication and control over which
 file is kept when a match set is automatically deleted. jdupes is not
 afraid of dropping features of low value; a prime example is the -1 switch
 which outputs all matches in a set on one line, a feature which was found
 to be useless in real-world tests and therefore thrown out.
 .
 jdupes can convert duplicate files in hardlinks or relative softlinks. It
 is useful in several scenarios, as in Debian packaging, to create relative
 symlinks to lots of duplicate files (it will substitute rdfind + symlinks
 commands, used to same purpose, when solving lintian duplicate-files).
 .
 Packages build for Linux versions have support to btrfs filesystem.

=== debian/tests/control ===
Test-Command: jdupes -v
Restrictions: superficial

Test-Command: jdupes debian/tests/files/

Test-Command: jdupes -m debian/tests/files/

Test-Command: jdupes -M debian/tests/files/

Test-Command: jdupes -r0 debian/tests/files/

Test-Command: jdupes -mr debian/tests/files/

Test-Command: jdupes -ru debian/tests/files/

# testdir is a test directory provided by the upstream
Test-Command: jdupes -r testdir

Test-Command: cp -a debian/tests/files/ $AUTOPKGTEST_TMP;
              jdupes -@1ADHiprls $AUTOPKGTEST_TMP/files;
              tree -C $AUTOPKGTEST_TMP/
Depends: @, tree:native

Test-Command: cp -a debian/tests/files/ $AUTOPKGTEST_TMP;
              jdupes -@rdNQzo time  -X size+:15 $AUTOPKGTEST_TMP/files;
              tree -C $AUTOPKGTEST_TMP/
Depends: @, tree:native
Restrictions: allow-stderr

Test-Command: fsdeploy original-files;
              jdupes -r $AUTOPKGTEST_TMP/
Restrictions: allow-stderr
Depends: @, forensics-samples-files

=== debian/watch ===
version=4
https://github.com/jbruchon/jdupes/releases .*/tags/v?(\d\S+)\.tar\.(?:bz2|gz|xz)

## jdupes 1.21.1

=== debian/changelog ===
jdupes (1.21.1-1) unstable; urgency=medium

  * New upstream version 1.21.1.
  * debian/patches/010_fix-dedup-btrfs.patch: removed because the upstream
    released a fixed the source code. Thanks.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 02 Dec 2022 14:41:09 -0300

jdupes (1.21.0-3) unstable; urgency=medium

  * debian/watch: updated the search rule to make it compliant with new
    standards of the GitHub.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 03 Oct 2022 00:11:08 -0300

jdupes (1.21.0-2) unstable; urgency=medium

  * debian/patches/010_fix-dedup-btrfs.patch: created to fix BTRFS
    deduplication broken since upstream/1.21.0. Thanks to Calum
    McConnell <calumlikesapplepie@gmail.com>. (Closes: #1019588)
  * debian/tests/control: improved all tests making checks over the results.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 17 Sep 2022 12:53:25 -0300

jdupes (1.21.0-1) unstable; urgency=medium

  * New upstream version 1.21.0.
  * debian/control: bumped Standards-Version to 4.6.1.
  * debian/copyright:
      - Changed the licensing for linux-dedupe-static.h, updated by the
        upstream.
      - Updated upstream and packaging copyright years.
  * debian/upstream/metadata: added field Donation.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 06 Sep 2022 01:26:40 -0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
 Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://github.com/jbruchon/jdupes
 Vcs-Browser: https://salsa.debian.org/debian/jdupes

=== debian/tests/control ===
Test-Command: jdupes -v | egrep 'jdupes [0-9]+\.[0-9]+\.[0-9]+ '
Restrictions: superficial

Test-Command: jdupes debian/tests/files/ | grep list -C2 | grep -C2 list3

Test-Command: jdupes -m debian/tests/files/ | egrep 'duplicate.+occupying'

Test-Command: jdupes -M debian/tests/files/ | grep -C20 list |
              grep -C20 list3 | egrep 'duplicate.+occupying'

Test-Command: jdupes -r0 debian/tests/files/ | grep -a openlogo-100.png

Test-Command: jdupes -mr debian/tests/files/ | egrep 'duplicate.+occupying'

Test-Command: jdupes -ru debian/tests/files/ | grep -C10 list2 | grep -C10 list8

# testdir is a test directory provided by the upstream
Test-Command: jdupes -r testdir | grep -C200 tinydupe2 | grep -C200 file100

Test-Command: cp -a debian/tests/files/ $AUTOPKGTEST_TMP;
              jdupes -@1ADHiprls $AUTOPKGTEST_TMP/files;
              tree -C $AUTOPKGTEST_TMP/ | grep -C50 list1| grep -C50 list7
Depends: @, tree:native

Test-Command: cp -a debian/tests/files/ $AUTOPKGTEST_TMP;
              jdupes -@rdNQzo time  -X size+:15 $AUTOPKGTEST_TMP/files;
              tree -C $AUTOPKGTEST_TMP/ | grep -C50 files
Depends: @, tree:native
Restrictions: allow-stderr

Test-Command: fsdeploy original-files;
              jdupes -r $AUTOPKGTEST_TMP/ 2>&1 | grep "No duplicates found"
Restrictions: allow-stderr
Depends: @, forensics-samples-files

## jdupes 1.21.2

=== Makefile ===
--- 
+++ 
@@ -55,16 +55,23 @@
 COMPILER_OPTIONS = -Wall -Wwrite-strings -Wcast-align -Wstrict-aliasing -Wstrict-prototypes -Wpointer-arith -Wundef
 COMPILER_OPTIONS += -Wshadow -Wfloat-equal -Waggregate-return -Wcast-qual -Wswitch-default -Wswitch-enum -Wconversion -Wunreachable-code -Wformat=2
 COMPILER_OPTIONS += -std=gnu99 -O2 -g -D_FILE_OFFSET_BITS=64 -fstrict-aliasing -pipe
-COMPILER_OPTIONS += -DSMA_MAX_FREE=11
+COMPILER_OPTIONS += -DSMA_MAX_FREE=11 -DNO_ATIME
 
 #####################################################################
 # no need to modify anything beyond this point                      #
 #####################################################################
 
 # Don't use unsupported compiler options on gcc 3/4 (OS X 10.5.8 Xcode)
-GCCVERSION = $(shell expr `gcc -v 2>&1 | grep 'gcc version ' | cut -d\  -f3 | cut -d. -f1` \>= 5)
+GCCVERSION = $(shell expr `LC_ALL=C gcc -v 2>&1 | grep 'gcc version ' | cut -d\  -f3 | cut -d. -f1` \>= 5)
 ifeq "$(GCCVERSION)" "1"
 	COMPILER_OPTIONS += -Wextra -Wstrict-overflow=5 -Winit-self
+endif
+
+# Are we running on a Windows OS?
+ifeq ($(OS), Windows_NT)
+	ifndef NO_WINDOWS
+		ON_WINDOWS=1
+	endif
 endif
 
 # Debugging code inclusion
@@ -92,7 +99,7 @@
 UNAME_S=$(shell uname -s)
 
 # MinGW needs this for printf() conversions to work
-ifeq ($(OS), Windows_NT)
+ifdef ON_WINDOWS
 	ifndef NO_UNICODE
 		UNICODE=1
 		COMPILER_OPTIONS += -municode
@@ -108,6 +115,34 @@
 	override undefine ENABLE_DEDUPE
 endif
 
+# Stack size limit can be too small for deep directory trees, so set to 16 MiB
+# The ld syntax for Windows is the same for both Cygwin and MinGW
+ifeq ($(OS), Windows_NT)
+COMPILER_OPTIONS += -Wl,--stack=16777216
+else ifeq ($(UNAME_S), Darwin)
+COMPILER_OPTIONS += -Wl,-stack_size -Wl,0x1000000
+else
+COMPILER_OPTIONS += -Wl,-z,stack-size=16777216
+endif
+
+# Bare-bones mode (for the adventurous lunatic) - includes all LOW_MEMORY options
+ifdef BARE_BONES
+LOW_MEMORY=1
+COMPILER_OPTIONS += -DSMA_PASSTHROUGH -DNO_DELETE -DNO_TRAVCHECK -DBARE_BONES
+COMPILER_OPTIONS += -DCHUNK_SIZE=4096 -DPATHBUF_SIZE=1024
+endif
+
+# Low memory mode
+ifdef LOW_MEMORY
+COMPILER_OPTIONS += -DLOW_MEMORY -DSMA_PAGE_SIZE=32768
+COMPILER_OPTIONS += -DNO_HARDLINKS -DNO_SYMLINKS -DNO_USER_ORDER -DNO_PERMS
+COMPILER_OPTIONS += -DNO_ATIME -DNO_JSON -DNO_EXTFILTER -DNO_CHUNKSIZE
+COMPILER_OPTIONS += -DUSE_JODY_HASH -DNO_NUMSORT
+ifndef BARE_BONES
+COMPILER_OPTIONS += -DCHUNK_SIZE=16384
+endif
+endif
+
 # Don't do clonefile on Mac OS X < 10.13 (High Sierra)
 ifeq ($(UNAME_S), Darwin)
 	DARWINVER := $(shell expr `uname -r | cut -d. -f1` \< 17)
@@ -135,11 +170,6 @@
 COMPILER_OPTIONS += -DSTATIC_DEDUPE_H
 endif
 
-# Low memory mode
-ifdef LOW_MEMORY
-COMPILER_OPTIONS += -DLOW_MEMORY -DSMA_PAGE_SIZE=32768 -DCHUNK_SIZE=16384 -DNO_HARDLINKS -DNO_SYMLINKS -DNO_USER_ORDER -DNO_PERMS
-endif
-
 CFLAGS += $(COMPILER_OPTIONS) $(CFLAGS_EXTRA)
 
 INSTALL_PROGRAM = $(INSTALL) -m 0755
@@ -152,7 +182,7 @@
 OBJS += jdupes.o jody_paths.o jody_sort.o jody_win_unicode.o jody_strtoepoch.o string_malloc.o oom.o
 OBJS += jody_cacheinfo.o
 OBJS += act_deletefiles.o act_linkfiles.o act_printmatches.o act_summarize.o act_printjson.o
-OBJS += xxhash.o
+OBJS += xxhash.o jody_hash.o
 OBJS += $(ADDITIONAL_OBJECTS)
 
 all: $(PROGRAM_NAME)
@@ -198,7 +228,7 @@
 	strip $(PROGRAM_NAME)$(PROGRAM_SUFFIX)
 
 clean:
-	$(RM) $(OBJS) $(OBJS_CLEAN) build_date.h $(PROGRAM_NAME) $(PROGRAM_NAME).exe *~ *.gcno *.gcda *.gcov
+	$(RM) $(OBJS) $(OBJS_CLEAN) build_date.h $(PROGRAM_NAME) $(PROGRAM_NAME).exe *~ .*.un~ *.gcno *.gcda *.gcov
 
 distclean: clean
 	$(RM) *.pkg.tar.*

=== debian/changelog ===
jdupes (1.21.2-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 13 Feb 2023 11:44:30 -0300

jdupes (1.21.2-2) unstable; urgency=medium

  * debian/patches/010_fix-no-file-travdone.patch: created to fix an internal
    error when jdupes runs over a non-existent directory. Thanks to Alberto
    Garcia <berto@igalia.com> and Jody Bruchon <jody@jodybruchon.com>.
    (Closes: #1030933)
  * debian/tests/control: added a new test, specific for #1030933.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 10 Feb 2023 17:17:56 -0300

jdupes (1.21.2-1) unstable; urgency=medium

  * New upstream version 1.21.2.
  * debian/control: bumped Standards-Version to 4.6.2.
  * debian/copyright: updated upstream and packaging copyright years.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 07 Feb 2023 23:15:20 -0300

## jdupes 1.21.3

=== debian/changelog ===
jdupes (1.21.3-1+deb12u1) bookworm; urgency=medium

  * debian/patches/010_fix-data-loss.patch: created to avoid a potential data
    loss caused by a wrong message that induces the users to use a range of
    values with -d option. Currently, the -d option doesn't understand ranges.
    (Closes: #1054237)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 08 Nov 2023 11:24:57 -0300

jdupes (1.21.3-1) unstable; urgency=medium

  * New upstream version 1.21.3.
  * debian/patches/010_fix-no-file-travdone.patch: removed because the upstream
    fixed the source code. Thanks!

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 20 Feb 2023 06:51:57 -0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
 Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/jbruchon/jdupes
 Vcs-Browser: https://salsa.debian.org/debian/jdupes

=== debian/tests/control ===
--- 
+++ 
@@ -32,3 +32,6 @@
               jdupes -r $AUTOPKGTEST_TMP/ 2>&1 | grep "No duplicates found"
 Restrictions: allow-stderr
 Depends: @, forensics-samples-files
+
+# Test for #1030933
+Test-Command: jdupes -r xyz-123 2>&1 | grep "No duplicates found"

=== debian/watch ===
version=4
https://github.com/jbruchon/jdupes/tags .*/tags/v?(\d\S+)\.tar\.(?:bz2|gz|xz)

## jdupes 1.26.1

=== Makefile ===
# jdupes Makefile

# Default flags to pass to the C compiler (can be overridden)
CFLAGS ?= -O2 -g

# PREFIX determines where files will be installed. Common examples
# include "/usr" or "/usr/local".
PREFIX = /usr/local

# PROGRAM_NAME determines the installation name and manual page name
PROGRAM_NAME = jdupes

# BIN_DIR indicates directory where program is to be installed.
# Suggested value is "$(PREFIX)/bin"
BIN_DIR = $(PREFIX)/bin

# MAN_DIR indicates directory where the jdupes man page is to be
# installed. Suggested value is "$(PREFIX)/man/man1"
MAN_BASE_DIR = $(PREFIX)/share/man
MAN_DIR = $(MAN_BASE_DIR)/man1
MAN_EXT = 1

# Required external tools
CC ?= gcc
INSTALL = install
RM      = rm -f
RMDIR   = rmdir -p
MKDIR   = mkdir -p
INSTALL_PROGRAM = $(INSTALL) -m 0755
INSTALL_DATA    = $(INSTALL) -m 0644

# Main object files
OBJS += args.o checks.o dumpflags.o extfilter.o filehash.o filestat.o jdupes.o helptext.o
OBJS += interrupt.o libjodycode_check.o loaddir.o match.o progress.o sort.o travcheck.o
OBJS += act_deletefiles.o act_linkfiles.o act_printmatches.o act_summarize.o act_printjson.o

# Configuration section
COMPILER_OPTIONS = -Wall -Wwrite-strings -Wcast-align -Wstrict-aliasing -Wstrict-prototypes -Wpointer-arith -Wundef
COMPILER_OPTIONS += -Wshadow -Wfloat-equal -Waggregate-return -Wcast-qual -Wswitch-default -Wswitch-enum -Wconversion -Wunreachable-code -Wformat=2
COMPILER_OPTIONS += -std=gnu11 -D_FILE_OFFSET_BITS=64 -fstrict-aliasing -pipe
COMPILER_OPTIONS += -DNO_ATIME

# Remove unused code if requested
ifdef GC_SECTIONS
 COMPILER_OPTIONS += -fdata-sections -ffunction-sections
 LINK_OPTIONS += -Wl,--gc-sections
endif


UNAME_S=$(shell uname -s)

# Don't use unsupported compiler options on gcc 3/4 (Mac OS X 10.5.8 Xcode)
# ENABLE_DEDUPE by default - macOS Sierra 10.12 and up required
ifeq ($(UNAME_S), Darwin)
 GCCVERSION = $(shell expr `LC_ALL=C gcc -v 2>&1 | grep 'gcc version ' | cut -d\  -f3 | cut -d. -f1` \>= 5)
 ifndef DISABLE_DEDUPE
  ENABLE_DEDUPE = 1
 endif
else
 GCCVERSION = 1
endif

ifeq ($(GCCVERSION), 1)
 COMPILER_OPTIONS += -Wextra -Wstrict-overflow=5 -Winit-self
endif

# Are we running on a Windows OS?
ifeq ($(OS), Windows_NT)
 ifndef NO_WINDOWS
  ON_WINDOWS=1
 endif
endif

# Debugging code inclusion
ifdef LOUD
 DEBUG=1
 COMPILER_OPTIONS += -DLOUD_DEBUG
endif
ifdef DEBUG
 COMPILER_OPTIONS += -DDEBUG
else
 COMPILER_OPTIONS += -DNDEBUG
endif
ifdef HARDEN
 COMPILER_OPTIONS += -Wformat -Wformat-security -D_FORTIFY_SOURCE=2 -fstack-protector-strong -fPIE -fpie -Wl,-z,relro -Wl,-z,now
endif

# MinGW needs this for printf() conversions to work
ifdef ON_WINDOWS
 ifndef NO_UNICODE
  UNICODE=1
  COMPILER_OPTIONS += -municode
  SUFFIX=.exe
 endif
 COMPILER_OPTIONS += -D__USE_MINGW_ANSI_STDIO=1 -DON_WINDOWS=1
 ifeq ($(UNAME_S), MINGW32_NT-5.1)
  OBJS += winres_xp.o
 else
  OBJS += winres.o
 endif
 override undefine ENABLE_DEDUPE
endif

# Bare-bones mode (for the adventurous lunatic) - includes all LOW_MEMORY options
ifdef BARE_BONES
 LOW_MEMORY=1
 COMPILER_OPTIONS += -DNO_DELETE -DNO_TRAVCHECK -DBARE_BONES -DNO_ERRORONDUPE
 COMPILER_OPTIONS += -DCHUNK_SIZE=4096 -DPATHBUF_SIZE=1024
endif

# Low memory mode
ifdef LOW_MEMORY
 USE_JODY_HASH = 1
 COMPILER_OPTIONS += -DLOW_MEMORY
 COMPILER_OPTIONS += -DNO_HARDLINKS -DNO_SYMLINKS -DNO_USER_ORDER -DNO_PERMS
 COMPILER_OPTIONS += -DNO_ATIME -DNO_JSON -DNO_EXTFILTER -DNO_CHUNKSIZE
 COMPILER_OPTIONS += -DNO_JODY_SORT
 ifndef BARE_BONES
  COMPILER_OPTIONS += -DCHUNK_SIZE=16384
 endif
endif

# Use jody_hash instead of xxHash if requested
ifdef USE_JODY_HASH
 COMPILER_OPTIONS += -DUSE_JODY_HASH
 OBJS_CLEAN += xxhash.o
 else
 ifndef EXTERNAL_HASH_LIB
  OBJS += xxhash.o
 endif
endif  # USE_JODY_HASH

# Stack size limit can be too small for deep directory trees, so set to 16 MiB
# The ld syntax for Windows is the same for both Cygwin and MinGW
ifndef LOW_MEMORY
 ifeq ($(OS), Windows_NT)
  COMPILER_OPTIONS += -Wl,--stack=16777216
 else ifeq ($(UNAME_S), Darwin)
  COMPILER_OPTIONS += -Wl,-stack_size -Wl,0x1000000
 else
  COMPILER_OPTIONS += -Wl,-z,stack-size=16777216
 endif
endif

# Don't do clonefile on Mac OS X < 10.13 (High Sierra)
ifeq ($(UNAME_S), Darwin)
 DARWINVER := $(shell expr `uname -r | cut -d. -f1` \< 17)
 ifeq "$(DARWINVER)" "1"
  COMPILER_OPTIONS += -DNO_CLONEFILE=1
 endif
endif

### Dedupe feature stuff (BTRFS, XFS, APFS)

# ENABLE_DEDUPE should be ON by default for Linux
ifeq ($(UNAME_S), Linux)
 ifndef DISABLE_DEDUPE
 ENABLE_DEDUPE = 1
 endif
endif

# Allow forced override of ENABLE_DEDUPE
ifdef DISABLE_DEDUPE
 override undefine ENABLE_DEDUPE
 override undefine STATIC_DEDUPE_H
endif

# Catch someone trying to enable dedupe in flags and turn on ENABLE_DEDUPE
ifneq (,$(findstring DENABLE_DEDUPE,$(CFLAGS) $(CFLAGS_EXTRA)))
 ENABLE_DEDUPE = 1
 ifdef DISABLE_DEDUPE
  $(error DISABLE_DEDUPE set but -DENABLE_DEDUPE is in CFLAGS. Choose only one)
 endif
endif

# Actually enable dedupe
ifdef ENABLE_DEDUPE
 COMPILER_OPTIONS += -DENABLE_DEDUPE
 OBJS += act_dedupefiles.o
else
 OBJS_CLEAN += act_dedupefiles.o
endif
ifdef STATIC_DEDUPE_H
 COMPILER_OPTIONS += -DSTATIC_DEDUPE_H
endif


### Find and use nearby libjodycode by default
ifndef IGNORE_NEARBY_JC
 ifneq ("$(wildcard ../libjodycode/libjodycode.h)","")
  $(info Found and using nearby libjodycode at ../libjodycode)
  COMPILER_OPTIONS += -I../libjodycode -L../libjodycode
  ifeq ("$(wildcard ../libjodycode/version.o)","")
   $(error You must build libjodycode before building jdupes)
  endif
 endif
 ifdef FORCE_JC_DLL
  LINK_OPTIONS += -l:../libjodycode/libjodycode.dll
 else
  LINK_OPTIONS += -ljodycode
 endif
endif


CFLAGS += $(COMPILER_OPTIONS) $(CFLAGS_EXTRA)
LDFLAGS += $(LINK_OPTIONS) $(LDFLAGS_EXTRA)


all: libjodycode_hint $(PROGRAM_NAME)

dynamic_jc: $(PROGRAM_NAME)
	$(CC) $(CFLAGS) $(OBJS) -Wl,-Bdynamic $(LDFLAGS) -o $(PROGRAM_NAME)$(SUFFIX)

static_jc: $(PROGRAM_NAME)
	$(CC) $(CFLAGS) $(OBJS) -Wl,-Bstatic $(LDFLAGS) -Wl,-Bdynamic -o $(PROGRAM_NAME)$(SUFFIX)

static: $(PROGRAM_NAME)
	$(CC) $(CFLAGS) $(OBJS) -static $(LDFLAGS) -o $(PROGRAM_NAME)$(SUFFIX)

static_stripped: $(PROGRAM_NAME) static
	strip $(PROGRAM_NAME)$(SUFFIX)

$(PROGRAM_NAME): $(OBJS)
	$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) -o $(PROGRAM_NAME)$(SUFFIX)

winres.o: winres.rc winres.manifest.xml
	./tune_winres.sh
	windres winres.rc winres.o

winres_xp.o: winres_xp.rc
	./tune_winres.sh
	windres winres_xp.rc winres_xp.o

installdirs:
	test -e $(DESTDIR)$(BIN_DIR) || $(MKDIR) $(DESTDIR)$(BIN_DIR)
	test -e $(DESTDIR)$(MAN_DIR) || $(MKDIR) $(DESTDIR)$(MAN_DIR)

install: $(PROGRAM_NAME) installdirs
	$(INSTALL_PROGRAM)	$(PROGRAM_NAME)$(SUFFIX)   $(DESTDIR)$(BIN_DIR)/$(PROGRAM_NAME)$(SUFFIX)
	$(INSTALL_DATA)		$(PROGRAM_NAME).1 $(DESTDIR)$(MAN_DIR)/$(PROGRAM_NAME).$(MAN_EXT)

uninstalldirs:
	-test -e $(DESTDIR)$(BIN_DIR) && $(RMDIR) $(DESTDIR)$(BIN_DIR)
	-test -e $(DESTDIR)$(MAN_DIR) && $(RMDIR) $(DESTDIR)$(MAN_DIR)

uninstall: uninstalldirs
	$(RM)	$(DESTDIR)$(BIN_DIR)/$(PROGRAM_NAME)$(SUFFIX)
	$(RM)	$(DESTDIR)$(MAN_DIR)/$(PROGRAM_NAME).$(MAN_EXT)

test:
	./test.sh

stripped: $(PROGRAM_NAME)
	strip $(PROGRAM_NAME)$(SUFFIX)

clean:
	$(RM) $(OBJS) $(OBJS_CLEAN) build_date.h $(PROGRAM_NAME)$(SUFFIX) *~ .*.un~ *.gcno *.gcda *.gcov

distclean: clean
	$(RM) -rf *.pkg.tar* jdupes-*-*/ jdupes-*-*.zip

chrootpackage:
	+./chroot_build.sh

package:
	+./generate_packages.sh $(ARCH)

libjodycode_hint:
	$(info hint: if ../libjodycode is built but jdupes won't run, try doing 'make static_jc')

=== debian/changelog ===
jdupes (1.26.1-1) unstable; urgency=medium

  * New upstream version 1.26.1.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 04 Jul 2023 19:20:02 -0300

jdupes (1.26-2) unstable; urgency=medium

  * Upload to unstable.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 04 Jul 2023 08:54:08 -0300

jdupes (1.26-1) experimental; urgency=medium

  * New upstream version 1.26.
  * debian/tests/control: fixed the first test.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 03 Jul 2023 23:55:49 -0300

jdupes (1.25.2-1) unstable; urgency=medium

  * New upstream version 1.25.2.
  * Upload to unstable.
  * debian/rules: removed no longer needed override_dh_auto_test.
  * debian/tests/control: added a new CI test to check the -q option.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 24 Jun 2023 08:38:17 -0300

jdupes (1.25.0-2) experimental; urgency=medium

  * debian/control: changed from libjodycode3-dev to libjodycode-dev in
    Build-Depends field. (see #1038752)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 21 Jun 2023 23:55:52 -0300

jdupes (1.25.0-1) unstable; urgency=medium

  * New upstream version 1.25.0.
  * debian/control: changed from libjodycode2-dev to libjodycode3-dev in
    Build-Depends field.
  * debian/patches/010_fix-hardlinks.patch: removed. This patch was taken from
    the current (new and fixed) upstream source code.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 18 Jun 2023 13:58:48 -0300

jdupes (1.24.0-2) unstable; urgency=medium

  * debian/patches/010_fix-hardlinks.patch: created to fix an issue
    with hardlinks. Thanks to Jody Bruchon <jody@jodybruchon.com>.
    (Closes: #1038417)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 17 Jun 2023 21:14:37 -0300

jdupes (1.24.0-1) unstable; urgency=medium

  * New upstream version 1.24.0.
  * debian/control: added libjodycode2-dev to Build-Depends field.
  * debian/copyright:
      - Removed block about oom.c and oom.h because these files no longer
        exist in source code. Consequently:
      - Removed the text of the CC0-1.0 license.
      - Updated upstream copyright data to reflect new statements from the
        source code.
  * debian/tests/control: removed option -D from command9 to avoid an error.
  * debian/upstream/metadata: added Documentation field.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 16 Jun 2023 16:23:08 -0300

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: utils
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
-Build-Depends: debhelper-compat (= 13)
+Build-Depends: debhelper-compat (= 13), libjodycode-dev
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/jbruchon/jdupes

## jdupes 1.27.3

=== Makefile ===
--- 
+++ 
@@ -30,13 +30,14 @@
 INSTALL_DATA    = $(INSTALL) -m 0644
 
 # Main object files
+OBJS += hashdb.o
 OBJS += args.o checks.o dumpflags.o extfilter.o filehash.o filestat.o jdupes.o helptext.o
 OBJS += interrupt.o libjodycode_check.o loaddir.o match.o progress.o sort.o travcheck.o
 OBJS += act_deletefiles.o act_linkfiles.o act_printmatches.o act_summarize.o act_printjson.o
 
 # Configuration section
 COMPILER_OPTIONS = -Wall -Wwrite-strings -Wcast-align -Wstrict-aliasing -Wstrict-prototypes -Wpointer-arith -Wundef
-COMPILER_OPTIONS += -Wshadow -Wfloat-equal -Waggregate-return -Wcast-qual -Wswitch-default -Wswitch-enum -Wconversion -Wunreachable-code -Wformat=2
+COMPILER_OPTIONS += -Wshadow -Wfloat-equal -Waggregate-return -Wcast-qual -Wswitch-default -Wswitch-enum -Wunreachable-code -Wformat=2
 COMPILER_OPTIONS += -std=gnu11 -D_FILE_OFFSET_BITS=64 -fstrict-aliasing -pipe
 COMPILER_OPTIONS += -DNO_ATIME
 
@@ -47,70 +48,18 @@
 endif
 
 
-UNAME_S=$(shell uname -s)
-
-# Don't use unsupported compiler options on gcc 3/4 (Mac OS X 10.5.8 Xcode)
-# ENABLE_DEDUPE by default - macOS Sierra 10.12 and up required
-ifeq ($(UNAME_S), Darwin)
- GCCVERSION = $(shell expr `LC_ALL=C gcc -v 2>&1 | grep 'gcc version ' | cut -d\  -f3 | cut -d. -f1` \>= 5)
- ifndef DISABLE_DEDUPE
-  ENABLE_DEDUPE = 1
- endif
-else
- GCCVERSION = 1
-endif
-
-ifeq ($(GCCVERSION), 1)
- COMPILER_OPTIONS += -Wextra -Wstrict-overflow=5 -Winit-self
-endif
-
-# Are we running on a Windows OS?
-ifeq ($(OS), Windows_NT)
- ifndef NO_WINDOWS
-  ON_WINDOWS=1
- endif
-endif
-
-# Debugging code inclusion
-ifdef LOUD
- DEBUG=1
- COMPILER_OPTIONS += -DLOUD_DEBUG
-endif
-ifdef DEBUG
- COMPILER_OPTIONS += -DDEBUG
-else
- COMPILER_OPTIONS += -DNDEBUG
-endif
-ifdef HARDEN
- COMPILER_OPTIONS += -Wformat -Wformat-security -D_FORTIFY_SOURCE=2 -fstack-protector-strong -fPIE -fpie -Wl,-z,relro -Wl,-z,now
-endif
-
-# MinGW needs this for printf() conversions to work
-ifdef ON_WINDOWS
- ifndef NO_UNICODE
-  UNICODE=1
-  COMPILER_OPTIONS += -municode
-  SUFFIX=.exe
- endif
- COMPILER_OPTIONS += -D__USE_MINGW_ANSI_STDIO=1 -DON_WINDOWS=1
- ifeq ($(UNAME_S), MINGW32_NT-5.1)
-  OBJS += winres_xp.o
- else
-  OBJS += winres.o
- endif
- override undefine ENABLE_DEDUPE
-endif
-
 # Bare-bones mode (for the adventurous lunatic) - includes all LOW_MEMORY options
 ifdef BARE_BONES
- LOW_MEMORY=1
+ LOW_MEMORY = 1
  COMPILER_OPTIONS += -DNO_DELETE -DNO_TRAVCHECK -DBARE_BONES -DNO_ERRORONDUPE
- COMPILER_OPTIONS += -DCHUNK_SIZE=4096 -DPATHBUF_SIZE=1024
+ COMPILER_OPTIONS += -DNO_HASHDB -DNO_HELPTEXT -DCHUNK_SIZE=4096 -DPATHBUF_SIZE=1024
 endif
 
 # Low memory mode
 ifdef LOW_MEMORY
  USE_JODY_HASH = 1
+ DISABLE_DEDUPE = 1
+ override undefine ENABLE_DEDUPE
  COMPILER_OPTIONS += -DLOW_MEMORY
  COMPILER_OPTIONS += -DNO_HARDLINKS -DNO_SYMLINKS -DNO_USER_ORDER -DNO_PERMS
  COMPILER_OPTIONS += -DNO_ATIME -DNO_JSON -DNO_EXTFILTER -DNO_CHUNKSIZE
@@ -120,9 +69,70 @@
  endif
 endif
 
+
+UNAME_S=$(shell uname -s)
+
+# Are we running on a Windows OS?
+ifeq ($(OS), Windows_NT)
+ ifndef NO_WINDOWS
+  ON_WINDOWS=1
+ endif
+endif
+
+# Debugging code inclusion
+ifdef LOUD
+ DEBUG=1
+ COMPILER_OPTIONS += -DLOUD_DEBUG
+endif
+ifdef DEBUG
+ COMPILER_OPTIONS += -DDEBUG
+else
+ COMPILER_OPTIONS += -DNDEBUG
+endif
+ifdef HARDEN
+ COMPILER_OPTIONS += -Wformat -Wformat-security -D_FORTIFY_SOURCE=2 -fstack-protector-strong -fPIE -fpie -Wl,-z,relro -Wl,-z,now
+endif
+
+# MinGW needs this for printf() conversions to work
+ifdef ON_WINDOWS
+ ifndef NO_UNICODE
+  UNICODE=1
+  COMPILER_OPTIONS += -municode
+ endif
+ SUFFIX=.exe
+ LIBEXT=.dll
+ COMPILER_OPTIONS += -D__USE_MINGW_ANSI_STDIO=1 -DON_WINDOWS=1
+ ifeq ($(UNAME_S), MINGW32_NT-5.1)
+  OBJS += winres_xp.o
+ else
+  OBJS += winres.o
+ endif
+ override undefine ENABLE_DEDUPE
+ DISABLE_DEDUPE = 1
+else
+ LIBEXT=.so
+endif
+
+# Don't use unsupported compiler options on gcc 3/4 (Mac OS X 10.5.8 Xcode)
+# ENABLE_DEDUPE by default - macOS Sierra 10.12 and up required
+ifeq ($(UNAME_S), Darwin)
+ GCCVERSION = $(shell expr `LC_ALL=C gcc -v 2>&1 | grep '[cn][cg] version' | sed 's/[^0-9]*//;s/[ .].*//'` \>= 5)
+ ifndef DISABLE_DEDUPE
+  ENABLE_DEDUPE = 1
+ endif
+else
+ GCCVERSION = 1
+ BDYNAMIC = -Wl,-Bdynamic
+ BSTATIC = -Wl,-Bstatic
+endif
+
+ifeq ($(GCCVERSION), 1)
+ COMPILER_OPTIONS += -Wextra -Wstrict-overflow=5 -Winit-self
+endif
+
 # Use jody_hash instead of xxHash if requested
 ifdef USE_JODY_HASH
- COMPILER_OPTIONS += -DUSE_JODY_HASH
+ COMPILER_OPTIONS += -DUSE_JODY_HASH -DNO_XXHASH2
  OBJS_CLEAN += xxhash.o
  else
  ifndef EXTERNAL_HASH_LIB
@@ -155,7 +165,7 @@
 # ENABLE_DEDUPE should be ON by default for Linux
 ifeq ($(UNAME_S), Linux)
  ifndef DISABLE_DEDUPE
- ENABLE_DEDUPE = 1
+  ENABLE_DEDUPE = 1
  endif
 endif
 
@@ -168,6 +178,7 @@
 # Catch someone trying to enable dedupe in flags and turn on ENABLE_DEDUPE
 ifneq (,$(findstring DENABLE_DEDUPE,$(CFLAGS) $(CFLAGS_EXTRA)))
  ENABLE_DEDUPE = 1
+ $(warn Do not enable dedupe in CFLAGS; use make ENABLE_DEDUPE=1 instead)
  ifdef DISABLE_DEDUPE
   $(error DISABLE_DEDUPE set but -DENABLE_DEDUPE is in CFLAGS. Choose only one)
  endif
@@ -194,10 +205,11 @@
    $(error You must build libjodycode before building jdupes)
   endif
  endif
- ifdef FORCE_JC_DLL
-  LINK_OPTIONS += -l:../libjodycode/libjodycode.dll
- else
-  LINK_OPTIONS += -ljodycode
+ STATIC_LDFLAGS += ../libjodycode/libjodycode.a
+ ifdef ON_WINDOWS
+  DYN_LDFLAGS += -l:../libjodycode/libjodycode$(LIBEXT)
+ else
+  DYN_LDFLAGS += -ljodycode
  endif
 endif
 
@@ -206,22 +218,22 @@
 LDFLAGS += $(LINK_OPTIONS) $(LDFLAGS_EXTRA)
 
 
-all: libjodycode_hint $(PROGRAM_NAME)
+all: libjodycode_hint $(PROGRAM_NAME) dynamic_jc
 
 dynamic_jc: $(PROGRAM_NAME)
-	$(CC) $(CFLAGS) $(OBJS) -Wl,-Bdynamic $(LDFLAGS) -o $(PROGRAM_NAME)$(SUFFIX)
+	$(CC) $(CFLAGS) $(OBJS) $(BDYNAMIC) $(LDFLAGS) $(DYN_LDFLAGS) -o $(PROGRAM_NAME)$(SUFFIX)
 
 static_jc: $(PROGRAM_NAME)
-	$(CC) $(CFLAGS) $(OBJS) -Wl,-Bstatic $(LDFLAGS) -Wl,-Bdynamic -o $(PROGRAM_NAME)$(SUFFIX)
+	$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) $(STATIC_LDFLAGS) $(BDYNAMIC) -o $(PROGRAM_NAME)$(SUFFIX)
 
 static: $(PROGRAM_NAME)
-	$(CC) $(CFLAGS) $(OBJS) -static $(LDFLAGS) -o $(PROGRAM_NAME)$(SUFFIX)
+	$(CC) $(CFLAGS) $(OBJS) -static $(LDFLAGS) $(STATIC_LDFLAGS) -o $(PROGRAM_NAME)$(SUFFIX)
 
 static_stripped: $(PROGRAM_NAME) static
-	strip $(PROGRAM_NAME)$(SUFFIX)
+	-strip $(PROGRAM_NAME)$(SUFFIX)
 
 $(PROGRAM_NAME): $(OBJS)
-	$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) -o $(PROGRAM_NAME)$(SUFFIX)
+	$(CC) $(CFLAGS) $(OBJS) $(BDYNAMIC) $(LDFLAGS) $(DYN_LDFLAGS) -o $(PROGRAM_NAME)$(SUFFIX)
 
 winres.o: winres.rc winres.manifest.xml
 	./tune_winres.sh

=== debian/changelog ===
jdupes (1.27.3-5~bpo12+2) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * debian/patches/040_fix-uniq-count.patch: created to fix a bit flag overlap
    between FF_NOT_UNIQUE and FF_HASHDB_DIRTY. This caused --unique to silently
    fail in detecting certain unique files. This bug is not present in current
    unstable/testing and is being fixed in current stable (Trixie, see
    #1117467). (Closes: #1063079)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 06 Oct 2025 03:04:05 -0300

jdupes (1.27.3-5~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 02 Dec 2023 23:21:39 -0300

jdupes (1.27.3-5) unstable; urgency=medium

  * jdupes has a homepage and a new repository (Codeberg). Consequently:
      - debian/control: updated the Homepage field.
      - debian/copyright: updated Upstream-Contact and Source fields.
      - debian/upstream/metadata: updated all data.
  * debian/patches/030_fix-crash-database.patch: created to fix a possible
    crash of the database. Thanks to Jody Bruchon (the upstream).

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 13 Nov 2023 22:46:45 -0300

jdupes (1.27.3-4) unstable; urgency=medium

  * debian/patches/020_fix-data-loss.patch: created to avoid a potential data
    loss caused by a wrong message that induces the users to use a range of
    values with -d option. Currently, the -d option doesn't understand ranges.
    (Closes: #1054237)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 19 Oct 2023 13:40:10 -0300

jdupes (1.27.3-3) unstable; urgency=medium

  * debian/watch: updated because the upstream moved the project from GitHub
    to Codeberg.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 10 Oct 2023 13:53:09 -0300

jdupes (1.27.3-2) unstable; urgency=medium

  * debian/patches/010_fix-FTBFS-Hurd.patch: created to fix the build on Hurd,
    declaring the PATH_MAX variable.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 29 Aug 2023 17:30:27 -0300

jdupes (1.27.3-1) unstable; urgency=medium

  * New upstream version 1.27.3.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 29 Aug 2023 15:01:06 -0300

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 13), libjodycode-dev
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
-Homepage: https://github.com/jbruchon/jdupes
+Homepage: https://www.jdupes.com/
 Vcs-Browser: https://salsa.debian.org/debian/jdupes
 Vcs-Git: https://salsa.debian.org/debian/jdupes.git

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq ($(DEB_HOST_ARCH_OS),linux)
      export OPT1="ENABLE_DEDUPE=1"
      export OPT2="STATIC_DEDUPE_H=1"
endif

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- $(OPT1) $(OPT2)

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

=== debian/tests/control ===
--- 
+++ 
@@ -1,4 +1,4 @@
-Test-Command: jdupes -v | egrep 'jdupes [0-9]+\.[0-9]+\.[0-9]+ '
+Test-Command: jdupes -v | egrep 'jdupes [0-9]+\.[0-9]+'
 Restrictions: superficial
 
 Test-Command: jdupes debian/tests/files/ | grep list -C2 | grep -C2 list3
@@ -18,7 +18,12 @@
 Test-Command: jdupes -r testdir | grep -C200 tinydupe2 | grep -C200 file100
 
 Test-Command: cp -a debian/tests/files/ $AUTOPKGTEST_TMP;
-              jdupes -@1ADHiprls $AUTOPKGTEST_TMP/files;
+              jdupes -@1AHiprls $AUTOPKGTEST_TMP/files;
+              tree -C $AUTOPKGTEST_TMP/ | grep -C50 list1| grep -C50 list7
+Depends: @, tree:native
+
+Test-Command: cp -a debian/tests/files/ $AUTOPKGTEST_TMP;
+              jdupes -@1AHiprlsq $AUTOPKGTEST_TMP/files;
               tree -C $AUTOPKGTEST_TMP/ | grep -C50 list1| grep -C50 list7
 Depends: @, tree:native

## jdupes 1.28.0

=== Makefile ===
--- 
+++ 
@@ -30,7 +30,7 @@
 INSTALL_DATA    = $(INSTALL) -m 0644
 
 # Main object files
-OBJS += hashdb.o
+OBJS += hashdb.o get_d_namlen.o
 OBJS += args.o checks.o dumpflags.o extfilter.o filehash.o filestat.o jdupes.o helptext.o
 OBJS += interrupt.o libjodycode_check.o loaddir.o match.o progress.o sort.o travcheck.o
 OBJS += act_deletefiles.o act_linkfiles.o act_printmatches.o act_summarize.o act_printjson.o
@@ -233,7 +233,7 @@
 	-strip $(PROGRAM_NAME)$(SUFFIX)
 
 $(PROGRAM_NAME): $(OBJS)
-	$(CC) $(CFLAGS) $(OBJS) $(BDYNAMIC) $(LDFLAGS) $(DYN_LDFLAGS) -o $(PROGRAM_NAME)$(SUFFIX)
+	:
 
 winres.o: winres.rc winres.manifest.xml
 	./tune_winres.sh

=== debian/changelog ===
jdupes (1.28.0-1) unstable; urgency=medium

  * New upstream version 1.28.0.
  * debian/control:
      - Added a relationship to libjodycode-dev.
      - Bumped Standards-Version to 4.7.0.
  * debian/copyright: updated upstream and packaging copyright years.
  * debian/docs: added ISSUES.txt.
  * debian/patches/: removed patches 020_fix-data-loss.patch and
    030_fix-crash-database.patch, already present in new upstream version.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 05 Aug 2024 19:05:55 -0300

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: utils
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
-Build-Depends: debhelper-compat (= 13), libjodycode-dev
-Standards-Version: 4.6.2
+Build-Depends: debhelper-compat (= 13), libjodycode-dev (>= 3.1.1)
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://www.jdupes.com/
 Vcs-Browser: https://salsa.debian.org/debian/jdupes

## jdupes 1.30.0

=== debian/changelog ===
jdupes (1.30.0-2~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 04 Oct 2025 16:46:16 -0300

jdupes (1.30.0-2) unstable; urgency=medium

  * Using libjodycode4 instead of libjodycode4t64. (Closes: #1116366)
  * debian/control: updated relationship for libjodycode-dev in Build-Depends
    field.
  * debian/tests/: created a new CI test for #1063079.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 28 Sep 2025 22:25:49 -0300

jdupes (1.30.0-1) unstable; urgency=medium

  * New upstream version 1.30.0.
  * debian/control:
      - Bumped Standards-Version to 4.7.2.
      - Removed no longer needed "Rules-Requires-Root: no" field.
      - Updated the relationship for libjodycode-dev in Build-Depends field.
  * debian/copyright: updated upstream and packaging copyright years.
  * debian/patches/:
      - 010_fix-FTBFS-Hurd.patch: removed because the upstream applied this
        patch. Thanks!
      - 010_add-gcc-hardening.patch: created to fix GCC hardening adding
        CPPFLAGS to ljc_vercheck.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 23 Sep 2025 22:17:29 -0300

=== debian/tests/control ===
--- 
+++ 
@@ -40,3 +40,13 @@
 
 # Test for #1030933
 Test-Command: jdupes -r xyz-123 2>&1 | grep "No duplicates found"
+
+# Test for #1063079
+Test-Command: cp debian/tests/files2.tar.gz $AUTOPKGTEST_TMP;
+              cd $AUTOPKGTEST_TMP;
+              tar -xvf files2.tar.gz;
+              rm files2.tar.gz;
+              JD1=$(jdupes -r files2/2/ files2/3/ | grep files2 | wc -l);
+              JD2=$(jdupes -ru files2/2/ files2/3/ | wc -l);
+              JDSUM=$((JD1 + JD2));
+              if [ "$JDSUM" -ne "1200" ]; then echo "Error: Invalid sum. Expected 1200, but received $JDSUM."; exit 1; fi
